/* 
 * $Id: config.c,v 1.6 1998/05/05 16:18:45 labovit Exp $
 */


#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <mrt.h>
#include <trace.h>
#include <io.h>
#include <stdarg.h>
#include <config_file.h>
#include "salserver.h"

/* globals */
extern salserver_t		SALSERVER;


void get_database_config (void) {
    config_add_output ("database %s\r\n", SALSERVER.dir);
    return;
}

/* config_database
 * database %s
 */
void config_database (uii_connection_t *uii, char *dir) { 
  config_notice (NORM, uii, "CONFIG database dir: %s\r\n", dir);
  SALSERVER.dir = dir;
  config_add_module (0, "database", get_database_config, NULL);

  return;
}

void get_multiserver_config (char *multiserver) {
  config_add_output ("multiserver %s\r\n", multiserver);
  return;
}

void config_multiserver (uii_connection_t *uii, char *line)
{ 
  char tmp[100];

  if (parse_line (uii->cp, "%s", tmp) >= 1) {
    if (sal_add_multiserver (tmp) < 1) {
      config_notice (NORM, uii, "CONFIG Error -- multiserver %s not added!\r\n", tmp);
    }
    config_add_module (0, "database", get_multiserver_config, strdup (tmp));
    config_notice (NORM, uii, "CONFIG multiserver %s added\r\n", tmp);
  }
  else {
    config_notice (NORM, uii, "CONFIG invalid format -- multiserver hostname\r\n");
  }

  return;
}




void config_archive (uii_connection_t *uii, char *file, char *type)
{ 
  char tmp1[100], tmp2[100];

  if (!strcmp ("DATE", type)) {
    config_notice (NORM, uii, "CONFIG DATE archive %s %s\r\n", file, type);
    sal_add_archive (file, 0); /* this should really be scheduled !!!! */
    config_add_module (1, "archive", schedule_get_archive_config, NULL);
    return;
  }
  else if (!strcmp ("TIME", type)) {
    config_notice (NORM, uii, "CONFIG TIME archive %s %s\r\n", file, type);
    sal_add_archive (file, 1);
    return;
  }

  config_notice (NORM, uii, "CONFIG -- invalid format: archive channel (DATE|TIME)\r\n");
  return;
}

/* config_create_default
 * A config file doesn't exist, so create a default one in memory
 */
void config_create_default () {
  char *tmp;
  CONFIG.ll_modules = LL_Create (0);

  tmp = strdup ("#####################################################################");
  config_add_module (0, "comment", (void *) get_comment_config, (void *) tmp);

  tmp = malloc (512);
  sprintf (tmp, "# SalServer -- MRT version %s ", MRT_VERSION);
  config_add_module (0, "comment", get_comment_config, (void *) tmp);
		
  tmp = strdup  ("#####################################################################");
  config_add_module (0, "comment", get_comment_config, (void *) tmp);


  config_add_module (0, "comment", get_comment_config, (void *) strdup ("!"));
  config_add_module (0, "debug", get_debug_config, NULL);
  config_add_module (0, "comment", get_comment_config, (void *) strdup ("!"));

  set_uii (UII, UII_PASSWORD, (void *) strdup ("none"));
  UII->initial_state = 1;
  /*set_uii (UII, UII_ACCESS_LIST, 1);*/
  /* create default access list */

  config_add_module (0, "password", get_uii_password, NULL);

  config_add_module (0, "comment", get_comment_config, (void *) strdup ("#"));

  tmp = strdup  ("#####################################################################");
  config_add_module (0, "comment", get_comment_config, (void *) tmp);
}
