/*
 * $Id: config.h,v 1.1.1.1 1998/01/06 20:06:56 labovit Exp $
 */

#ifndef _CONFIG_H
#define _CONFIG_H

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 256
#endif

#include <mrt.h>


typedef struct _config_master_t {
  int		line;		/* when parsing file, current lineno */
  /* I'm not sure the following are used */
  int		sockfd;		/* socket if being configured by user */
  int		state;          /* router, interface, etc */
  int		instance;	/* protocol, or interface number */
  int		negate;		/* command prefeced by a "no" */
  char          *password;      /* non-encrypted password */
  int		access_list;	/* access list num to match telnet IP against */
  trace_t	*trace;
} config_master_t;

typedef struct _config_command_t {
  char *name;
  int (*call_fn)();
  char *format;
  char *description;
} config_command_t;

int init_config(trace_t *);
int config_from_file (char *);
int parse_debug (uii_connection_t * uii, trace_t * trace);


#endif /* _CONFIG_H */
